diff --git a/hw/scsi-generic.c b/hw/scsi-generic.c
index 33d7e52..fe58975 100644
--- a/hw/scsi-generic.c
+++ b/hw/scsi-generic.c
@@ -96,19 +96,19 @@ static void scsi_command_complete(void *opaque, int ret)
         s->senselen = r->io_header.sb_len_wr;
 
     if (ret != 0) {
-	if (ret == -EDOM) {
-	    /* sg driver uses EDOM to signal queue busy */
-	    fprintf(stderr, "%s: sg queue busy\n", __FUNCTION__);
-	    r->req.status = TASK_SET_FULL;
-	} else {
-	    scsi_req_print(&r->req);
-	    fprintf(stderr, "%s: ret %d (%s)\n", __FUNCTION__,
-		    ret, strerror(-ret));
-	    s->senselen = scsi_build_sense(SENSE_CODE(INVALID_FIELD),
-					   s->sensebuf, SCSI_SENSE_BUF_SIZE, 0);
-	    s->driver_status = SG_ERR_DRIVER_SENSE;
-	    r->req.status = CHECK_CONDITION;
-	}
+        if (ret == -EDOM) {
+            /* sg driver uses EDOM to signal queue busy */
+            fprintf(stderr, "%s: sg queue busy\n", __FUNCTION__);
+            r->req.status = TASK_SET_FULL;
+        } else {
+            scsi_req_print(&r->req);
+            fprintf(stderr, "%s: ret %d (%s)\n", __FUNCTION__,
+                    ret, strerror(-ret));
+            s->senselen = scsi_build_sense(SENSE_CODE(INVALID_FIELD),
+                                           s->sensebuf, SCSI_SENSE_BUF_SIZE, 0);
+            s->driver_status = SG_ERR_DRIVER_SENSE;
+            r->req.status = CHECK_CONDITION;
+        }
     } else {
         if (s->driver_status & SG_ERR_DRIVER_TIMEOUT) {
             scsi_req_print(&r->req);
@@ -163,7 +163,7 @@ static int execute_command_run(SCSIGenericReq *r,
     int i = 0;
     DPRINTF("-----------------------> Issuing SG_IO CDB len %u: 0x", r->req.cmd.len);
     for (i = 0; i < r->req.cmd.len; i++)
-		printf("%02x ", r->req.cmd.buf[i]);
+        printf("%02x ", r->req.cmd.buf[i]);
     printf("\n");
     }
 #endif
@@ -183,7 +183,7 @@ static int execute_command_buf(SCSIGenericReq *r,
     r->io_header.dxferp = buf;
     r->io_header.dxfer_len = buflen;
     DPRINTF("execute BUF: %p, dxfer_len %u\n", r->io_header.dxferp,
-		r->io_header.dxfer_len);
+            r->io_header.dxfer_len);
     return execute_command_run(r, complete);
 
 }
@@ -196,8 +196,8 @@ static int execute_command_iov(SCSIGenericReq *r,
     r->io_header.dxferp = iov->iov;
     r->io_header.dxfer_len = iov->size;
     DPRINTF("execute IOV: iovec_count: %u, dxferp: %p, dxfer_len: %u\n",
-		r->io_header.iovec_count, r->io_header.dxferp,
-		r->io_header.dxfer_len);
+            r->io_header.iovec_count, r->io_header.dxferp,
+            r->io_header.dxfer_len);
     return execute_command_run(r, complete);
 }
 
@@ -226,10 +226,10 @@ static void scsi_req_fixup(SCSIRequest *req)
 {
     switch(req->cmd.buf[0]) {
     case WRITE_10:
-        req->cmd.buf[1] &= ~0x08;	/* disable FUA */
+        req->cmd.buf[1] &= ~0x08;       /* disable FUA */
         break;
     case READ_10:
-        req->cmd.buf[1] &= ~0x08;	/* disable FUA */
+        req->cmd.buf[1] &= ~0x08;       /* disable FUA */
         break;
     case REWIND:
     case START_STOP:
@@ -394,13 +394,14 @@ static int scsi_generic_map(SCSIGenericReq *r, QEMUSGList *sg)
     for (i = 0; i < sg->nsg;) {
         cur_addr = sg->sg[i].base + cur_offset;
         cur_len = sg->sg[i].len - cur_offset;
-	DPRINTF("Using cur_addr: 0x%016lx cur_len: 0x%016lx\n", cur_addr, cur_len);
+        DPRINTF("Using cur_addr: 0x%016lx cur_len: 0x%016lx\n",
+                cur_addr, cur_len);
 
         mem = cpu_physical_memory_map(cur_addr, &cur_len, is_write);
         if (!mem)
             goto err;
 
-	DPRINTF("Adding iovec for mem: %p len: 0x%016lx\n", mem, cur_len);
+        DPRINTF("Adding iovec for mem: %p len: 0x%016lx\n", mem, cur_len);
         qemu_iovec_add(&r->iov, mem, cur_len);
         cur_offset += cur_len;
         if (cur_offset == sg->sg[i].len) {
@@ -449,7 +450,7 @@ static int scsi_generic_req_common(SCSIRequest *req, uint8_t *buffer)
         DPRINTF("Unimplemented LUN %d\n",
                 req->lun ? req->lun : req->cmd.buf[1] >> 5);
         s->senselen = scsi_build_sense(SENSE_CODE(LUN_NOT_SUPPORTED),
-				       s->sensebuf, SCSI_SENSE_BUF_SIZE, 0);
+                                       s->sensebuf, SCSI_SENSE_BUF_SIZE, 0);
         s->driver_status = SG_ERR_DRIVER_SENSE;
         req->status = CHECK_CONDITION;
         return 1;